Index: palm/trunk/SCRIPTS/mrun
===================================================================
--- palm/trunk/SCRIPTS/mrun	(revision 1282)
+++ palm/trunk/SCRIPTS/mrun	(revision 1289)
@@ -22,5 +22,7 @@
 # Current revisions:
 # ------------------
-# 
+# comments translated to English
+# necriam-, fimm-, ibmy-, and sgi-specific code removed
+# export of variables for palm and interpret_config removed
 #
 # Former revisions:
@@ -143,9 +145,10 @@
 
  
-    # VARIABLENVEREINBARUNGEN + DEFAULTWERTE
-
- set +o allexport    # SICHERHEITSHALBER UNTERBINDEN, DA SONST EVTL. STAGEOUT
-                     # NICHT LAUEFT (TOO MANY ARGUMENTS - PROBLEM)
- set +o noclobber    # EXISTIERENDE DATEIEN DUERFEN UEBERSCHRIEBEN WERDEN
+    # DECLARATION OF VARIABLES AND THEIR DEFUALT VALUES
+
+ set +o allexport    # SUPPRESS EXPORT OF ALL VARIABLES, SINCE IN THE PAST THIS
+                     # LES TO PROBLEMS IN ROUTINES CALLED BY MRUN
+                     # (TOO MANY ARGUMENTS - PROBLEM)
+ set +o noclobber    # EXISTING FILES ARE ALLOWED TO BE OVERWRITTEN
 
  AddFilenames=""
@@ -182,6 +185,5 @@
  fftw_lib=""
  fftw_support=false
- fimm=false
- fname=test
+  fname=test
  fromhost=""
  global_revision=""
@@ -199,5 +201,4 @@
  link_local_output=false
  localhost_realname=$(hostname)
- local_compile=false
  local_dvrserver_running=.FALSE.
  locat=normal
@@ -223,5 +224,4 @@
  output_list=""
  package_list=""
- punkte="..........................................................."
  queue=none
  read_from_config=""
@@ -248,7 +248,6 @@
  run_coupled_model=false
  run_mode=""
- scirocco=false
  store_on_archive_system=false
- striche="  ----------------------------------------------------------------------------"
+ dashes="  ----------------------------------------------------------------------------"
  silent=false
  source_list=""
@@ -261,5 +260,5 @@
  usern=$LOGNAME
  use_openmp=false
- version="MRUN  2.0 Rev$Rev$"
+ version="MRUN  2.1 Rev$Rev$"
  working_directory=`pwd`
  TOPT=""
@@ -268,60 +267,17 @@
 
  typeset -i  iec=0 iic=0 iin=0 ioc=0 iout=0 stagein_anz=0 stageout_anz=0
- typeset -x -i  memory=0   # has to be exported here, otherwise an unknown side
-                           # effect may cause data loss when getopts is reading the
-                           # script-option arguments
+ typeset -x -i  memory=0   # HAS TO BE EXPORTED HERE, OTHERWISE AN UNKNOWN SIDE
+                           # SIDE EFFECT MAY CAUSE DATA LOSS WHEN GETOPTS IS READING THE
+                           # SCRIPT-OPTION ARGUMENTS
  typeset -i  cputime i ii iia iii iio icycle inode ival jobges jobsek last_char_int maxcycle minuten nodes pes remaining_pes sekunden tp1
 
 
 
-
-    # EINZELNE VARIABLE FUER HAUPTPROGRAMM EXPORTIEREN
- export  cpurest fname host localhost return_addres return_username remotecall tasks_per_node
-
-    # FOLGENDE VARIABLEN MUESSEN FUER DIE INTERPRETATION DER KONFIGURATIONSDATEI
-    # EXPORTIERT WERDEN
- export  afname config_file cpp_opts cpumax do_batch do_trace fname fromhost
- export  group_number input_list numprocs output_list queue run_mode
-
-
- 
-    # FEHLERBEHANDLUNG
-    # BEI EXIT:
+    # ERROR HANDLING IN CASE OF EXIT
  trap 'rm -rf  $working_directory/tmp_mrun
-       if [[ $locat != localhost ]]
-       then
-#          if [[ ! -f ${mrun_path}/statistik/mrun_statistik ]]
-#          then
-#             cat  >  ${mrun_path}/statistik/mrun_statistik  <<  %STATEND%
-#MRUN-calls on $localhost
-#
-#date and time                      user        localhost   remotehost  termination mrun-command
-#--------------------------------------------------------------------------------------------------------------------
-#%STATEND%
-#             chmod  666  ${mrun_path}/statistik/mrun_statistik
-#          fi
-#
-#             # EINTRAG IN DIE STATISTIK-DATEI
-#          string1=`date`                  #-L35
-#          string2=$usern                  #-L12
-#          string3=$localhost_realname     #-L12
-#          string4=$host                   #-L12
-#          string5=$locat                  #-L12
-#          if [[ "$job_on_file" = ""  &&  $locat != control_c  &&  $locat != user_abort ]]
-#          then
-#             if [[ $do_batch = true ]]
-#             then
-#                printf "$string1$string2$string3$string4$string5$mrun_com \n"  >>  ${mrun_path}/statistik/mrun_statistik
-#             else
-#                printf "$string1$string2$string3$string4$string5$mc \n"  >>  ${mrun_path}/statistik/mrun_statistik
-#             fi
-#          fi
-          echo " " > /dev/null
-       fi
-
-       if [[ $locat != normal  &&  $locat != control_c  &&  $locat != local_compile ]]
-       then
-
-              # EVENTUELLE ERROR-KOMMANDOS ABARBEITEN
+       if [[ $locat != normal  &&  $locat != control_c ]]
+       then
+
+              # CARRY OUT ERROR-COMMANDS GIVEN IN THE CONFIGURATION FILE (EC:)
           (( i = 0 ))
           while (( i < iec ))
@@ -363,5 +319,5 @@
 
 
-    # BEI TERMINAL-BREAK:
+    # ACTIONS IN CASE OF TERMINAL-BREAK (CONTROL-C):
  trap 'rm -rf  $working_directory/tmp_mrun
        rm -rf  $working_directory/tmp_check_namelist_files
@@ -394,6 +350,6 @@
 
 
-    # SHELLSCRIPT-OPTIONEN EINLESEN UND KOMMANDO NEU ZUSAMMENSETZEN, FALLS ES
-    # FUER FOLGEJOBS BENOETIGT WIRD
+    # READ SHELLSCRIPT-OPTIONS AND REBUILD THE MRUN-COMMAND STRING (MC),
+    # WHICH WILL BE USED TO START RESTART-JOBS
  while  getopts  :a:AbBc:Cd:D:Fg:G:h:H:i:IkK:m:M:n:o:O:p:P:q:r:R:s:St:T:u:U:vw:xX:yY:zZ option
  do
@@ -447,10 +403,10 @@
 
 
-    # EVTL. POSITIONSPARAMETER EINLESEN
-    # ZUR ZEIT GIBT ES NUR DEN PARAMETER ? (=KURZINFO)
+    # SKIP GIVEN OPTIONS TO READ POSITIONAL PARAMETER, IF GIVEN
+    # CURRENTLY ONLY PARAMETER ? (TO OUTPUT A SHORT COMMAND INFO) IS ALLOWED
  (( to_shift = $OPTIND - 1 ))
  shift $to_shift
 
-    # KURZE AUFRUFBESCHREIBUNG WIRD HIER AUSGEGEBEN
+    # PRINT SHORT DESCRIPTION OF MRUN OPTIONS
  if [[ "$1" = "?" ]]
  then
@@ -515,5 +471,5 @@
 
 
-    # KURZE STARTMELDUNG
+    # SHORT STARTING MESSAGE
  printf "\n*** $version "
  printf "\n    will be executed.     Please wait ..."
@@ -521,5 +477,5 @@
 
 
-    # PRUEFEN, OB KONFIGURATIONS-DATEI VORHANDEN
+    # CHECK, IF CONFIGURATION FILE EXISTS
  if [[ ! -f $config_file ]]
  then
@@ -531,5 +487,5 @@
 
 
-    # HOST-IDENTIFIER (local_host) AUS KONFIGURATIONSDATEI BESTIMMEN
+    # DETERMINE THE HOST-IDENTIFIER (localhost) FROM THE CONFIGURATION FILE
  line=""
  grep  "%host_identifier"  $config_file  >  tmp_mrun
@@ -559,21 +515,20 @@
 
 
-    # HOSTSPEZIFISCHE VARIABLEN SETZEN
+    # SET HOST-SPECIFIC VARIABLES
  case  $localhost_realname  in
      (r1*|r2*|h01*|b01*)     archive_system=tivoli;;
      (cs*)                   archive_system=ut;;
-     (fimm.bccs.uib.no)      fimm=true;;
-     (gate|n-sx)             PATH=$PALM_BIN:$PATH:/usr/bin/nqsII;;
-     (scirocco)              scirocco=true;;
  esac
 
 
- 
-    # BASISNAME DER INPUT-DATEIEN GLEICH ALLGEMEINEM BASISNAMEN SETZEN,
-    # WENN NICHT VOM BENUTZER ANDERS BESTIMMT
+    # ??? THIS SHOULD BE DECRIBED IN THE MRUN DOCUMENTATION ??? 
+    # SET BASENAME OF THE INPUT-FILES TO THE GENERAL BASENAME (GIVEN BY OPTION -d),
+    # IF IT HAS NOT BEEN SET BY THE USER DIFFERENTLY (USING OPTION -a)
  [[ "$afname" = "" ]]  &&  afname=$fname
 
 
-    # EVTL. RUN-MODUS DEN I/O-LISTEN HINZUFUEGEN
+    # ADD RUN-FILE ACTIVATION STRINGS (GIVEN BY OPTION -r) TO THE
+    # RESPECTIVE LISTS FOR ACTIVATING THE INPUT/OUTPUT FILE CONNECTION
+    # STATEMENTS IN THE CONFIGURATION FILE
  if [[ "$run_mode" != "" ]]
  then
@@ -583,8 +538,9 @@
 
 
-    # RECHNERNAMEN ABSPEICHERN, VON DEM AUS JOB GESTARTET WIRD,
-    # ALLERDINGS NUR DANN, WENN NICHT PER OPTION -H BEREITS EIN WERT
-    # ZUGEWIESEN WURDE (MRUN MACHT DIES IMMER, WENN ES SELBST BATCH-JOBS
-    # STARTET)
+    # ??? is this (and the respective option -H) really required ???
+    # STORE HOSTNAME, FROM WHICH THE JOB IS STARTED,
+    # BUT ONLY IF IT HASN'T BEEN ALREADY SET BY OPTION -H
+    # (MRUN IS AUTOMATICALLY SETTING THIS OPTION IN THE MRUN-CALLS WITHIN
+    # THOSE BATCH-JOBS, WHICH ARE CREATED BY MRUN ITSELF)
  if [[ "$fromhost" = "" ]]
  then
@@ -593,8 +549,8 @@
 
 
-    # PRUEFEN, OB AUF REMOTE-MASCHINE GERECHNET WERDEN SOLL
-    # WERT VON do_remote WIRD FUER DATEIVERBINDUNGEN BENOETIGT.
-    # WENN AUF REMOTE-MASCHINE GERECHNET WIRD, IST GLEICHZEITIG KLAR,
-    # DASS EIN BATCH-JOB GESTARTET WERDEN MUSS
+    # CHECK, IF EXECUTION SHALL TO BE DONE ON THE REMOTE-MACHINE.
+    # VALUE OF do_remote IS IMPORTANT FOR THE FILE CONNECTIONS.
+    # IN CASE OF EXECUTION ON A REMOTE-MACHINE, A BATCH-JOB HAS
+    # TO BE SUBMITTED (I.E. do_bacth=true)
  if [[ -n $host  &&  "$host" != $localhost ]]
  then
@@ -602,5 +558,5 @@
     do_remote=true
     case  $host  in
-        (ibm|ibmh|ibmkisti|ibmku|ibms|ibmy|nech|necriam|lccrayb|lccrayh|lccrayf|lcflow|lckyoto|lcsgib|lcsgih|unics|lcxe6|lcxt5m|lck|lckiaps|lckordi|lckyuh|lckyut|lcsb)  true;;
+        (ibm|ibmh|ibmkisti|ibmku|ibms|nech|lccrayb|lccrayh|lccrayf|lcflow|lckyoto|unics|lcxe6|lcxt5m|lck|lckiaps|lckordi|lckyuh|lckyut|lcsb)  true;;
         (*)  printf "\n"
              printf "\n  +++ sorry: execution of batch jobs on remote host \"$host\""
@@ -613,8 +569,7 @@
 
 
-     # ZUSATZBEDINGUNGEN (OPTION -K) AUSWERTEN
+     # EVALUATE ADDITIONAL CONDITIONS GIVEN BY OPTION -K
  if [[ -n $additional_conditions ]]
  then
-#    echo $additional_conditions | cut -d" " -f1-3 | read  cond1  cond2  dummy
     cond1=`echo $additional_conditions | cut -d" " -f1`
     cond2=`echo $additional_conditions | cut -d" " -s -f2`
@@ -630,32 +585,22 @@
 
 
-      # KOPPLUNGSEIGENSCHAFTEN (-Y) AUSWERTEN UND coupled_mode BESTIMMEN
+      # EVALUATE MODEL COUPLING FEATURES (OPTION -Y) AND DETERMINE coupled_mode
  if [[ $run_coupled_model = true ]] 
  then
 
-    if  [[ -n $coupled_dist ]]
-    then
-
-       numprocs_atmos=`echo $coupled_dist | cut -d" " -s -f1`
-       numprocs_ocean=`echo $coupled_dist | cut -d" " -s -f2`
-
-       if (( $numprocs_ocean + $numprocs_atmos != $numprocs ))
-       then
-
-          printf "\n  +++ number of processors does not fit to specification by \"-Y\"."
-          printf "\n      PEs (total)     : $numprocs"
-          printf "\n      PEs (atmosphere): $numprocs_atmos"
-          printf "\n      PEs (ocean)     : $numprocs_ocean"
-          locat=coupling; exit
-
-       fi
-
-    else
-
-       (( numprocs_ocean = $numprocs / 2 ))
-       (( numprocs_atmos = $numprocs / 2 ))
-
-    fi
-    coupled_dist=`echo "$numprocs_atmos $numprocs_ocean"`
+    numprocs_atmos=`echo $coupled_dist | cut -d" " -s -f1`
+    numprocs_ocean=`echo $coupled_dist | cut -d" " -s -f2`
+
+    if (( $numprocs_ocean + $numprocs_atmos != $numprocs ))
+    then
+
+       printf "\n  +++ number of processors does not fit to specification by \"-Y\"."
+       printf "\n      PEs (total)     : $numprocs"
+       printf "\n      PEs (atmosphere): $numprocs_atmos"
+       printf "\n      PEs (ocean)     : $numprocs_ocean"
+       locat=coupling; exit
+
+    fi
+
 
        # GET coupled_mode FROM THE CONFIG FILE
@@ -673,6 +618,5 @@
 
 
-    # PRUEFEN, OB EVTL. BEI VORHERGEHENDEM LAUF (KETTENJOB) EINE
-    # ARCHIVIERUNG FEHLGESCHLAGEN IST
+    # CHECK, IF FILE-ARCHIVING HAS FAILED IN PREVIOUS JOB (OF A JOB-CHAIN)
  if [[ -f ~/job_queue/ARCHIVE_ERROR_$fname ]]
  then
@@ -689,6 +633,6 @@
 
 
-    # WERTE VON MRUN-OPTIONEN SICHERN UND DAMIT GEGEBENENFALLS SPAETER DIE
-    # IN DER KONFIGURAIONSDATEI ANGEGEBENEN WERTE UEBERSTEUERN
+    # SAVE VALUES OF MRUN-OPTIONS SICHERN IN ORDER TO OVERWRITE
+    # THOSE VALUES GIVEN IN THE CONFIGURATION-FILE
  mrun_memory=$memory
  mrun_group_number=$group_number
@@ -697,10 +641,12 @@
 
 
-    # LESEN UND INTERPRETIEREN DER KONFIGURATIONS-DATEI VOM SHELLSCRIPT AUS
-    # VORUEBERGEHEND ZWINGEND AUF LINUX-RECHNERN
+    # READ AND EVALUATE THE CONFIGURATION-FILE FROM WITHIN THIS SHELLSCRIPT
+    # (OPTION -S). THE DEFAULT IS USING THE ROUTINE interpret_config
  if [[ "$read_from_config" = false ]]
  then
 
     [[ $silent = false ]]  &&  printf "\n    Reading the configuration file... "
+
+       # READ THE CONFIGURATION FILE LINE BY LINE
     while  read zeile
     do
@@ -708,13 +654,12 @@
 
 
-          # ZUERST EVENTUELL VORKOMMENDE ENVIRONMENT-VARIABLEN DURCH IHRE WERTE
-          # ERSETZEN
+          # FIRST REPLACE ENVIRONMENT-VARIABLES BY THEIR RESPECTIVE VALUES
        eval  zeile=\"$zeile\"
 
 
-          # INTERPRETATION DER ZEILE
+          # INTERPRET THE LINE
        if [[ "$(echo $zeile)" = "" ]]
        then
-             # LEERZEILE, KEINE AKTION
+             # EMPTY LINE, NO ACTION
           continue
 
@@ -722,5 +667,5 @@
        then
 
-             # ZEILE IST KOMMENTARZEILE
+             # LINE IS A COMMENT LINE
           true
 
@@ -728,7 +673,6 @@
        then
 
-             # ZEILE DEFINIERT ENVIRONMENT-VARIABLE
+             # LINE DEFINES AN ENVIRONMENT-VARIABLE
           zeile=$(echo $zeile | cut -c2-)
-#          echo $zeile | cut -d" " -f1-5 | read  var  value  for_host  for_cond1  for_cond2
           var=`echo $zeile | cut -d" " -f1`
           value=`echo $zeile | cut -d" " -s -f2`
@@ -740,20 +684,20 @@
           then
 
-                # BEI COMPILER- CPP- ODER LINKEROPTIONEN EVTL ":" DURCH " "
-                # ERSETZEN. "::" WIRD DURCH ":" ERSETZT.
+                # REPLACE ":" BY " " IN COMPILER- CPP- OR LINKER-OPTIONS,
+                # "::" IS REPLACED BY ":".
              value=`echo $value | sed 's/::/%DUM%/g' | sed 's/:/ /g' | sed 's/%DUM%/:/g'`
 
 
-                # ENVIRONMENT-VARIABLE WIRD WERT AUS KONFIGURATIONSDATEI
-                # ZUGEWIESEN, WENN SIE SELBST NOCH KEINEN WERT UEBER DIE
-                # ENTSPRECHENDE SCRIPT-OPTION ERHALTEN HAT. SOLCHE
-                # VARIABLEN HAETTEN DANN DEN WERT "" ODER IM INTEGER-FALL DEN
-                # WERT 0.  ALLGEMEINE REGEL ALSO: SCRIPT-OPTION GEHT UEBER
-                # KONFIGURATIONSDATEI
+                # VALUE FROM THE CONFIGURATION-FILE IS ASSIGNED TO THE
+                # ENVIRONMENT-VARIABLE, BUT ONLY IF NO VALUE HAS BEEN ALREADY
+                # ASSIGNED WITHIN THIS SCRIPT (E.G. BY SCRIPT-OPTIONS).
+                # NON-ASSIGNED VARIABLES HAVE VALUE "" OR 0 (IN CASE OF INTEGER).
+                # HENCE THE GENERAL RULE IS: SCRIPT-OPTION OVERWRITES THE
+                # CONFIGURATION-FILE.
              if [[ "$(eval echo \$$var)" = ""  ||  "$(eval echo \$$var)" = "0" ]]
              then
                 eval  $var=\$value
 
-                   # EVTL. BILDSCHIRMAUSGABEN DER ENVIRONMENT-VARIABLEN
+                   # TERMINAL OUTPUT OF ENVIRONMENT-VARIABLES, IF TRACEBACK IS SWITCHED on
                 if [[ $do_trace = true ]]
                 then
@@ -762,8 +706,8 @@
              fi
 
-                # WENN ENVIRONMENT-VARIABLE HOST VEREINBART, DANN SOFORT AUSWERTEN
-                # WERT VON do-remote WIRD BEI DATEIVERBINDUNGEN BENOETIGT
-                # WENN AUF REMOTE-MASCHINE GERECHNET WIRD, IST GLEICHZEITIG KLAR,
-                # DASS EIN BATCH-JOB GESTARTET WERDEN MUSS
+                # IF AN ENVIRONMENT-VARIABLE DETERMINES THE HOST, THEN EVALUATE IT IMMEDIATELY:
+                # VALUE OF do-remote IS REQUIRED FOR THE FILE CONNECTIONS (COPY OF I/O FILES).
+                # IF EXECUTION IS SCHEDULED FOR A REMOTE-MASCHINE, A BATCH-JOB
+                # MUST HAVE TO BE STARTED
              if [[ $var = host ]]
              then
@@ -773,5 +717,5 @@
                    do_remote=true
                    case  $host  in
-                       (ibm|ibmh|ibmkisti|ibmku|ibms|ibmy|lccrayb|lccrayh|lccrayf|lcflow|lckyoto|lcsgib|lcsgih|nech|necriam|unics|lcxe6|lcxt5m|lck|lckiaps|lckordi|lckyuh|lckyut|lcsb)  true;;
+                       (ibm|ibmh|ibmkisti|ibmku|ibms|lccrayb|lccrayh|lccrayf|lcflow|lckyoto|nech|unics|lcxe6|lcxt5m|lck|lckiaps|lckordi|lckyuh|lckyut|lcsb)  true;;
                        (*)  printf "\n  +++ sorry: execution of batch jobs on remote host \"$host\""
                             printf "\n      is not available"
@@ -783,7 +727,7 @@
              fi
 
-                # VOM BENUTZER DEFINIERTE ENVIRONMENT VARIABLEN MUESSEN PRINZIPIELL
-                # EXPORTIERT WERDEN, DA SIE VIELLEICHT IN WEITER UNTEN AUFZURUFEN-
-                # DEN PROGRAMMEN BENOETIGT WERDEN
+                # USER-DEFINED ENVIRONMENT VARIABLES MUST BE EXPORTED,
+                # BECAUSE THEY MAY BE REQUIRED IN OTHER SCRIPTS CALLED
+                # BY MRUN (E.G. subjob)
              export  $var
           fi
@@ -795,5 +739,5 @@
        then
 
-             # ZEILE DEFINIERT ERROR-KOMMANDO
+             # LINE DEFINES ERROR-COMMAND
           (( iec = iec + 1 ))
           zeile=$(echo $zeile | cut -c4-)
@@ -803,5 +747,5 @@
        then
 
-             # ZEILE DEFINIERT INPUT-KOMMANDO
+             # LINE DEFINES INPUT-COMMAND
           (( iic = iic + 1 ))
           zeile=$(echo $zeile | cut -c4-)
@@ -811,5 +755,5 @@
        then
 
-             # ZEILE DEFINIERT OUTPUT-KOMMANDO
+             # LINE DEFINES OUTPUT-COMMAND
           (( ioc = ioc + 1 ))
           zeile=$(echo $zeile | cut -c4-)
@@ -818,9 +762,8 @@
        else
 
-             # ZEILE DEFINIERT DATEIVERBINDUNG. EINLESEN DER DATEIEIGENSCHAFTEN
-             # s2a: in/out - Feld
-             # s2b: loc    - Feld (optional)
-             # s2c: tr/ar  - Feld (optional)
-#          echo $zeile | cut -d" " -f1-2 | read  s1  s2
+             # LINE DEFINES FILE CONNECTION. READ THE FILE ATTRIBUTES.
+             # s2a: in/out - field
+             # s2b: loc    - field (optional)
+             # s2c: tr/ar  - field (optional)
           s1=`echo $zeile | cut -d" " -f1`
           s2=`echo $zeile | cut -d" " -s -f2`
@@ -831,9 +774,7 @@
              s2c=""
           else
-#             echo $s2 | cut -d":" -f2-3 | sed 's/:/ /g' | read  s2b  s2c
              s2b=`echo $s2 | cut -d":" -f2 | sed 's/:/ /g'`
              s2c=`echo $s2 | cut -d":" -s -f3 | sed 's/:/ /g'`
           fi
-#          echo $zeile | cut -d" " -f3-6 | read  s3  s4  s5  s6
           s3=`echo $zeile | cut -d" " -f3`
           s4=`echo $zeile | cut -d" " -s -f4`
@@ -842,9 +783,10 @@
 
        
-             # ABSPEICHERN DER DATEIVERBINDUNG, FALLS IN INPUT- ODER OUTPUT-LIST
-             # VERMERKT. VARIABLE S3 KANN AUCH LISTE ENTHALTEN (FELDTRENNER ":")
-             # DATEIVERBINDUNG WIRD DANN NICHT ABGESPEICHERT UND GEPRUEFT, WENN
-             # PROGRAMMLAUF AUF REMOTE-MASCHINE ERFOLGT UND DATEI NUR LOKAL VOR-
-             # HANDEN SEIN MUSS (D.H. s2b = loc)
+             # STORE FILE CONNECTION, IF ACTIVATED BY ACTIVATION-STRING FROM
+             # INPUT- OR OUTPUT-LIST.
+             # VARIABLE S3 MAY CONTAIN A LIST OF ACTIVATION STRINGS (FIELD-SEPERATOR ":").
+             # IF EXECUTION IS SCHEDULED FOR A REMOTE-MACHINE AND THE FILE IS ONLY
+             # LOCALLY REQUIRED ON THAT MACHINE (I.E. s2b = loc), THE FILE CONNECTION
+             # IS NOT CHECKED AND STORED.
           IFSALT="$IFS"; IFS="$IFS:"
           if [[ "$s2a" = in  &&  ! ( $do_remote = true  &&  ( "$s2b" = loc  ||  "$s2b" = locopt ) ) ]]
@@ -894,13 +836,11 @@
 
 
-       # INTERPRETATION DER KONFIGURATIONSDATEI MITTELS FORTRAN 90 - PROGRAMM
+       # EVALUATE THE CONFIGURATION-FILE BY FORTRAN-PROGRAM
     [[ $silent = false ]]  &&  printf "..."
-    export  cond1 cond2 config_file do_remote do_trace input_list localhost output_list
-    export  interpreted_config_file=.icf.$RANDOM
-
-
-
-       # ENVIRONMENT-VARIABLEN FUER INTERPRET_CONFIG UEBER NAMELIST_DATEI ZUR
-       # VERFUEGUNG STELLEN
+    interpreted_config_file=.icf.$RANDOM
+
+
+
+       # PROVIDE VALUES OF ENVIRONMENT-VARIABLE FOR interpret_config VIA NAMELIST-FILE
     cat  >  .mrun_environment  <<  %%END%%
  &mrun_environment  cond1 = '$cond1', cond2 = '$cond2', 
@@ -912,41 +852,35 @@
 %%END%%
 
-    if [[ $localhost_realname = "sx-fep" ]]
-    then
-       /home/COAR/NC/raasch/pub/interpret_config_necriam.x
+    if [[ "$host" != $localhost ]]
+    then
+
+          # REMOTE JOB FROM LOCAL HOST: JUST TAKE THE FIRST EXECUTABLE FOUND
+       interpret_config_executable=`ls -1 ${PALM_BIN}/interpret_config*.x 2>/dev/null`
+       if [[ $? != 0 ]]
+       then
+          printf "\n\n  +++ no interpret_config found"
+          printf "\n      run \"mbuild -u -h ...\" to generate utilities for this host"
+          locat=interpret_config; exit
+       fi
+       interpret_config_executable=`echo $interpret_config_executable | cut -d" " -f1`
+       $interpret_config_executable
+
     else
 
-       if [[ "$host" != $localhost ]]
-       then
-
-             # REMOTE JOB FROM LOCAL HOST: JUST TAKE THE FIRST EXECUTABLE FOUND
-          interpret_config_executable=`ls -1 ${PALM_BIN}/interpret_config*.x 2>/dev/null`
-          if [[ $? != 0 ]]
-          then
-             printf "\n\n  +++ no interpret_config found"
-             printf "\n      run \"mbuild -u -h ...\" to generate utilities for this host"
-             locat=interpret_config; exit
-          fi
-          interpret_config_executable=`echo $interpret_config_executable | cut -d" " -f1`
-          $interpret_config_executable
-
+          # CHECK, IF THERE IS AN EXECUTABLE FOR THE BLOCK
+       if [[ ! -f ${PALM_BIN}/interpret_config${block}.x ]]
+       then
+          printf "\n\n  +++ no interpret_config found for given block \"$cond1 $cond2\""
+          printf "\n      run \"mbuild -u -h ...\" to generate utilities for this block"
+          locat=interpret_config; exit
        else
-
-             # CHECK, IF THERE IS AN EXECUTABLE FOR THE BLOCK
-          if [[ ! -f ${PALM_BIN}/interpret_config${block}.x ]]
-          then
-             printf "\n\n  +++ no interpret_config found for given block \"$cond1 $cond2\""
-             printf "\n      run \"mbuild -u -h ...\" to generate utilities for this block"
-             locat=interpret_config; exit
-          else
-             interpret_config${block}.x
-          fi
-
-       fi
+          interpret_config${block}.x
+       fi
+
     fi
     rm .mrun_environment
 
 
-       # AUSFUEHRUNG DER GENERIERTEN SHELL-KOMMANDOS IN DIESER SHELL
+       # EXECUTE SHELL-COMMANDS GENERATED BY interpret_config WITHIN THIS SHELL
     chmod  u+x  $interpreted_config_file
     export PATH=$PATH:.
@@ -957,5 +891,5 @@
 
 
-    # OPTIONSWERTE UEBERSTEUERN KONFIGURATIONSDATEI
+    # VALUES OF MRUN-OPTIONS OVERWRITE THOSE FROM THE CONFIGURATION-FILE
  [[ $mrun_memory     != 0   ]]  &&  memory=$mrun_memory
  [[ "$mrun_group_number" != "none" ]]  &&  group_number=$mrun_group_number
@@ -966,13 +900,13 @@
 
 
-    # QUELLTEXTVERZEICHNIS AUF LOKALER MASCHINE AUS KONFIGURATIONSDATEI
-    # BESTIMMEN (WUERDE SONST EVTL. DAS VERZEICHNIS DES JEWEILS UNTER -h
-    # ANGEGEBENEN REMOTE-RECHNERS SEIN)
-    # BEI BATCH-JOBS SIND DIE ZU UEBERSETZENDEN PROGRAMMTEILE SCHON KOMPLETT
+    # ON THE LOCAL MACHINE, DETERMINE (FROM THE CONFIGURATION-FILE) THE PATH
+    # FOR SOURCE-FILES TO BE COMPILED. 
+    # IN A BATCH-JOB, SOURCES (ROUTINES TO BE COMPILED) ARE COMPLETE ALREADY.
+    # BEFORE MRUN IS CALLED IN THE JOB, SOURCES_COMPLETE = true IS ASSIGNED (SEE FURTHER BELOW).
  if [[ "$SOURCES_COMPLETE" = "" ]]
  then
 
-       # ZUERST PRUEFEN, OB EIN GLOBALER QUELLTEXTPFAD FUER ALLE RECHNER
-       # VEREINBART WURDE
+       # FIRST CHECK, IF A GLOBAL SOURCE PATH (TO BE USED FOR ALL HOSTS)
+       # HAS BEEN DEFINED
     source_path=""
     line=""
@@ -1031,7 +965,7 @@
 
 
-    # GLOBALE REVISIONSNUMMER ERMITTELN (FORTSETZUNGSLAEUFEN WIRD DIESE
-    # DURCH OPTION -G MITGETEILT)
- if [[ "$global_revision" = ""   &&  $host != "ibmkisti" ]]
+    # GET THE GLOBAL REVISION-NUMBER OF THE SVN-REPOSITORY
+    # (HANDED OVER TO RESTART-RUNS USING OPTION -G)
+ if [[ "$global_revision" = ""  &&  $host != "ibmkisti" ]]
  then
     global_revision=`svnversion $source_path  2>/dev/null`
@@ -1040,9 +974,7 @@
 
 
-    # NOCHMAL PRUEFEN, OB AUF REMOTE-MASCHINE GERECHNET WERDEN SOLL
-    # (HOST KANN IN KONFIGURATIONSDATEI ANDERS FESTGELEGT WORDEN SEIN)
-    # WERT VON do_remote WIRD FUER DATEIVERBINDUNGEN BENOETIGT.
-    # WENN AUF REMOTE-MASCHINE GERECHNET WIRD, IST GLEICHZEITIG KLAR,
-    # DASS EIN BATCH-JOB GESTARTET WERDEN MUSS
+    # ??? das darf doch eigentlich garnicht passieren, weil optionen config-datei uebersteuern ???
+    # CHECK AGAIN, IF EXECUTION SHALL BE DONE ON A REMOTE-HOST (BATCH-JOB).
+    # (HOST MAY HAVE CHANGED DUE TO SETTINGS IN THE CONFIGURATION-FILE)
  if [[ -n $host  &&  "$host" != $localhost ]]
  then
@@ -1050,5 +982,5 @@
     do_remote=true
     case  $host  in
-        (ibm|ibmh|ibmkisti|ibmku|ibms|ibmy|lccrayb|lccrayh|lccrayf|lcflow|lckyoto|lcsgib|lcsgih|nech|necriam|unics|lcxe6|lcxt5m|lck|lckiaps|lckordi|lckyuh|lckyut|lcsb)  true;;
+        (ibm|ibmh|ibmkisti|ibmku|ibms|lccrayb|lccrayh|lccrayf|lcflow|lckyoto|nech|unics|lcxe6|lcxt5m|lck|lckiaps|lckordi|lckyuh|lckyut|lcsb)  true;;
         (*)  printf "\n"
              printf "\n  +++ sorry: execution of batch jobs on remote host \"$host\""
@@ -1061,9 +993,9 @@
 
 
-    # PRUEFUNG EINIGER PROZESSORZAHLANGABEN BEI RECHNUNGEN AUF PARALLELRECHNERN
+    # IN CASE OF PARALLEL EXECUTION, CHECK SOME SPECIFICATIONS CONCERNING PROCESSOR NUMBERS
  if [[ "$cond1" = parallel  ||  "$cond2" = parallel ]]
  then
 
-       # PRUEFEN, OB DIE ANZAHL DER ZU VERWENDENDEN PES ANGEGEBEN WURDE
+       # CHECK, IF NUMBER OF CORES TO BE USED HAS BEEN GIVEN
     if [[ ! -n $numprocs ]]
     then
@@ -1076,7 +1008,6 @@
     fi
 
-       # PRUEFEN, OB DIE PROZESSORANZAHL PRO KNOTEN ANGEGEBEN WURDE (GGF.
-       # DEFAULT-WERT SETZEN) UND OB SIE EIN GANZZAHLIGER TEILER DER
-       # GESAMTPROZESSORANZAHL IST
+       # CHECK, IF THE NUMBER OF CORES PER NODE HAS BEEN GIVEN UND IF IT IS AN
+       # INTEGRAL DIVISOR OF THE TOTAL NUMBER OF CORES GIVEN BY OPTION -X
     if [[ "$tasks_per_node" = ""  &&  $host != lcflow  &&  $host != lcxt5m ]]
     then
@@ -1114,22 +1045,8 @@
 
 
-       # IBMY HAT NUR EINEN KNOTEN
-    if [[ $host = ibmy ]]
-    then
-       if [[ "$tasks_per_node" != ""  &&  "$tasks_per_node" != "$numprocs" ]]
-       then
-          printf "\n"
-          printf "\n  +++ on ibmy, tasks per node (option \"-T\") must be equal to the"
-          printf "\n      total number of processors (option \"-X\")"
-          printf "\n      values of this mrun-call: \"-T $tasks_per_node\" \"-X $numprocs\""
-          locat=tasks_per_node; (( iec = 0 )); exit 
-       fi
-    fi
-
-
        # SETTINGS FOR SUBJOB-COMMAND
     OOPT="-O $threads_per_task"
 
-       # GESAMTZAHL DER KNOTEN BESTIMMEN
+       # SET THE TOTAL NUMBER OF NODES, REQUIRED FOR THE SUBJOB-COMMAND (SEE FURTHER BELOW)
     if [[ "$tasks_per_node" != "" ]]
     then
@@ -1137,6 +1054,5 @@
     fi
 
-       # PRUEFEN, OB NODE USAGE EINEN ERLAUBTEN WERT HAT BZW. DEN DEFAULT
-       # SETZEN
+       # CHECK node_usage FOR ALLOWED VALUES AND SET DEFAULT VALUE, IF NECESSARY
     if [[ $node_usage = default ]]
     then
@@ -1144,7 +1060,4 @@
        then
           node_usage=shared
-       elif [[ $(echo $host | cut -c1-5) = lcsgi ]]
-       then
-          node_usage=singlejob
        else
           node_usage=not_shared
@@ -1162,5 +1075,5 @@
  fi
 
-    # PRUEFEN, OB HOSTFILE EXISTIERT
+    # CHECK IF HOSTFILE EXISTS
  if [[ -n $hostfile ]]
  then
@@ -1173,25 +1086,6 @@
  fi
 
-    # PRUEFEN, OB RHOSTS DATEI EXISTIERT. GEGEBENENFALLS ANLEGEN BZW. ERWEITERN
- if [[ $host = ibmy  &&  $do_remote = false ]]
- then
-    if [[ ! -f $HOME/.rhosts ]]
-    then
-       echo  "gfdl5.yonsei.ac.kr"  >  $HOME/.rhosts
-       printf "\n\n  *** file:"
-       printf "\n           $HOME/.rhosts"
-       printf "\n      was created\n"
-    fi
-    if [[ $(grep -c gfdl5.yonsei.ac.kr $HOME/.rhosts) = 0 ]]
-    then
-       echo  "gfdl5.yonsei.ac.kr"  >>  $HOME/.rhosts
-       printf "\n\n  *** file:"
-       printf "\n           $HOME/.rhosts"
-       printf "\n      was extended by the name of the current host\n"
-    fi
- fi
-
-
-    # Set default value for the maximum number of parallel io streams
+
+    # SET DEFAULT VALUE FOR THE MAXIMUM NUMBER OF PARALLEL IO STREAMS
  if [[ "$maximum_parallel_io_streams" = "" ]]
  then
@@ -1200,5 +1094,5 @@
 
 
-    # Set port number option for calls of ssh/scp, subjob and batch_scp scripts
+    # SET PORT NUMBER OPTION FOR CALLS OF SSH/SCP, subjob AND batch_scp SCRIPTS
  if [[ "$scp_port" != "" ]]
  then
@@ -1208,5 +1102,5 @@
 
 
-    # FALLS NICHT VORGEGEBEN, DEFAULT-QUEUE AUF DER ZIELMASCHINE FESTLEGEN
+    # SET DEFAULT-QUEUE, IF NOT GIVEN
  if [[ $queue = none ]]
  then
@@ -1214,14 +1108,10 @@
         (ibmh)       queue=cluster;;
         (ibmkisti)   queue=class.32plus;;
-        (ibmy)       queue=parallel;;
         (lckiaps)    queue=normal;;
         (lckyoto)    queue=ph;;
         (lckyuh)     queue=fx-single;;
         (lckyut)     queue=cx-single;;
-        (lcsgib)     queue=testq;;
-        (lcsgih)     queue=testq;;
         (lctit)      queue=S;;
         (nech)       queue=none;;
-        (necriam)    queue=SP;;
         (unics)      queue=unics;;
     esac
@@ -1229,7 +1119,6 @@
 
 
-    # VOLLSTAENDIGE DATEINAMEN DER INPUT-FILES BILDEN,
-    # INPUT-DATEIEN AUF VORHANDENSEIN PRUEFEN UND EVTL. HOECHSTE ZYKLUSNUMMER
-    # ERMITTELN
+    # GENERATE FULL FILENAMES OF INPUT-FILES, INCLUDING THEIR PATH
+    # CHECK, IF INPUT-FILES EXIST, AND DETERMINE HIGHEST CYCLE NUMBER (IF CYCLES EXIST)
  (( i = 0 ))
  while (( i < iin ))
@@ -1238,18 +1127,19 @@
     (( maxcycle = 0 ))
 
-       # NAMENSBILDUNG (EVTL. IST FESTER DATEINAME VORGEGEBEN)
+       # GENERATE PATH AND FULL FILE NAME (then-BRANCH: FIXED FULL NAME IS GIVEN, I.E. THE
+       # FILE IDENTIFIER IS NOT PART OF THE FILENAME))
     if [[ "${actionin[$i]}" = di ]]
     then
-       remotepathin[$i]=${pathin[$i]}/${endin[$i]}  # REMOTE-PFAD ERST AUF
-                                                    # REM-MASCHINE AUSWERTEN
+       remotepathin[$i]=${pathin[$i]}/${endin[$i]}  # EVALUATE REMOTE-PATH ON THE REMOTE
+                                                    # HOST ONLY
        eval filename=${pathin[$i]}/${endin[$i]}
     else
-       remotepathin[$i]=${pathin[$i]}/${afname}${endin[$i]}  # REMOTE-PFAD ERST AUF
-                                                             # REM-MASCHINE AUSWERTEN
+       remotepathin[$i]=${pathin[$i]}/${afname}${endin[$i]}  # EVALUATE REMOTE-PATH ON THE REMOTE
+                                                             # HOST ONLY
        eval filename=${pathin[$i]}/${afname}${endin[$i]}
     fi
     eval pathname=${pathin[$i]}
 
-#   SAVE INPUT FILE NAME FOR PARAMETER FILE CHECK
+       # SAVE INPUT FILE NAME FOR PARAMETER FILE CHECK
     if [[ ("${transin[$i]}" = job) && (-f $filename) ]]
     then
@@ -1257,5 +1147,5 @@
     fi
 
-       # PRUEFEN AUF VORHANDENSEIN
+       # CHECK IF FILE EXISTS
     if [[ $(ls $filename* 2>&1 | grep -c "not found") = 1  || \
           $(ls $filename* 2>&1 | grep -c "nicht gefunden") = 1  || \
@@ -1263,9 +1153,6 @@
           $(ls $filename* 2>&1 | grep -c "does not exist") = 1 ]]
     then
-          # DATEIEN MIT EXTENSION (Z.B. NC) MUESSEN NICHT ZWINGEND VORHANDEN
-          # SEIN, DESHALB IN SOLCHEN FAELLEN KEIN ABBRUCH. DIES IST NUR EINE
-          # VORUEBERGEHENDE LOESUNG (OKT 05). NICHT ZWINGEND BENOETIGTE
-          # EINGABEDATEIEN SOLLTEN EINE SPEZIELLE OPTION IN DER DATEI-
-          # VERBINDUNGSANWEISUNG BEKOMMEN (Z.B. inopt?)
+
+          # FILES WITH ATTRIBUTE locopt ARE OPTIONAL. NO ABORT, IF THEY DO NOT EXIST.
        if [[ "${transin[$i]}" != "locopt" ]]
        then
@@ -1284,5 +1171,5 @@
     else
 
-          # ZYKLUSNUMMER FESTSTELLEN
+          # DETERMINE THE FILE'S CYCLE NUMBER
        ls -1 -d $filename    >   filelist  2>/dev/null
        ls -1 -d $filename.*  >>  filelist  2>/dev/null
